<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en"><head>

<meta charset="utf-8">
<meta name="generator" content="quarto-1.3.361">

<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes">

<meta name="author" content="Štěpán Zapadlo (505579)">
<meta name="dcterms.date" content="2023-12-06">

<title>IA168 AGT – Homework #2</title>
<style>
code{white-space: pre-wrap;}
span.smallcaps{font-variant: small-caps;}
div.columns{display: flex; gap: min(4vw, 1.5em);}
div.column{flex: auto; overflow-x: auto;}
div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
ul.task-list{list-style: none;}
ul.task-list li input[type="checkbox"] {
  width: 0.8em;
  margin: 0 0.8em 0.2em -1em; /* quarto-specific, see https://github.com/quarto-dev/quarto-cli/issues/4556 */ 
  vertical-align: middle;
}
</style>


<script src="hw2_files/libs/clipboard/clipboard.min.js"></script>
<script src="hw2_files/libs/quarto-html/quarto.js"></script>
<script src="hw2_files/libs/quarto-html/popper.min.js"></script>
<script src="hw2_files/libs/quarto-html/tippy.umd.min.js"></script>
<script src="hw2_files/libs/quarto-html/anchor.min.js"></script>
<link href="hw2_files/libs/quarto-html/tippy.css" rel="stylesheet">
<link href="hw2_files/libs/quarto-html/quarto-syntax-highlighting.css" rel="stylesheet" class="quarto-color-scheme" id="quarto-text-highlighting-styles">
<link href="hw2_files/libs/quarto-html/quarto-syntax-highlighting-dark.css" rel="prefetch" class="quarto-color-scheme quarto-color-alternate" id="quarto-text-highlighting-styles">
<script src="hw2_files/libs/bootstrap/bootstrap.min.js"></script>
<link href="hw2_files/libs/bootstrap/bootstrap-icons.css" rel="stylesheet">
<link href="hw2_files/libs/bootstrap/bootstrap.min.css" rel="stylesheet" class="quarto-color-scheme" id="quarto-bootstrap" data-mode="light">
<link href="hw2_files/libs/bootstrap/bootstrap-dark.min.css" rel="prefetch" class="quarto-color-scheme quarto-color-alternate" id="quarto-bootstrap" data-mode="dark">

  <script src="https://polyfill.io/v3/polyfill.min.js?features=es6"></script>
  <script src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-chtml-full.js" type="text/javascript"></script>

</head>

<body>

<div id="quarto-content" class="page-columns page-rows-contents page-layout-article">
<div id="quarto-margin-sidebar" class="sidebar margin-sidebar">
<div class="quarto-alternate-formats"><h2>Other Formats</h2><ul><li><a href="../../hw2.pdf"><i class="bi bi-file-pdf"></i>PDF</a></li></ul></div></div>
<main class="content" id="quarto-document-content">

<header id="title-block-header" class="quarto-title-block default">
<div class="quarto-title">
<h1 class="title">IA168 AGT – Homework #2</h1>
</div>



<div class="quarto-title-meta">

    <div>
    <div class="quarto-title-meta-heading">Author</div>
    <div class="quarto-title-meta-contents">
             <p>Štěpán Zapadlo (505579) </p>
          </div>
  </div>
    
    <div>
    <div class="quarto-title-meta-heading">Published</div>
    <div class="quarto-title-meta-contents">
      <p class="date">December 6, 2023</p>
    </div>
  </div>
  
    
  </div>
  

</header>

<div class="hidden">
$$ % Declare mathematics (so they can be overwritten for PDF)
% Font styles
% Sets
% Basic notation - vectors and random variables
%standard vector
%differentiated vector
%still a vector if vi doesn’t work
%differ. vector
%matrix
%differ. matrix
%#TODO
<p>%#TODO</p>
% Basic notation - general
% Special symbols
% Basic functions
%image %cardinality
% Operators - Analysis
% Linear algebra
% Linear algebra - Matrices
% Statistics
% Game Theory
% Optimization
% Useful commands
<p>$$</p>
</div>
<p>In <strong>all</strong> of the exercises, <strong>finite-horizon</strong> extensive-form game will be assumed, as necessary concepts for infinite-horizon extensive-form game were not covered in the lectures.</p>
<div id="exr-first" class="theorem exercise">
<p><span class="theorem-title"><strong>Exercise 1 </strong></span>Give a formal description of rock-paper-scissors as a two-player <strong>imperfect</strong>-information extensive-form game (i.e., according to the definition from the lectures).</p>
</div>
<div class="solution proof">
<p><span class="proof-title"><em>Solution</em>. </span>Quite easily, one can represent rock-paper-scissors as a graph prescribing a two-player imperfect-information extensive-form game <span class="math inline">\({G}_{\mathrm{imp}}\)</span> shown in <a href="#fig-rps-imp">Figure&nbsp;1</a>.</p>
<div id="fig-rps-imp" class="quarto-figure quarto-figure-center anchored">
<figure class="figure">
<p><img src="problem_1_sol.drawio.svg" class="img-fluid figure-img"></p>
<figcaption class="figure-caption">Figure&nbsp;1: Graph of rock-paper-scissors as a two-player imperfect-information game <span class="math inline">\({G}_{\mathrm{imp}}\)</span></figcaption>
</figure>
</div>
<p>Now recall from the lectures that an imperfect-information game <span class="math inline">\({G}_{\mathrm{imp}}\)</span> is defined as a tuple <span class="math inline">\({G}_{\mathrm{imp}} = \left( {G}_{\mathrm{perf}}, I \right)\)</span>, where <span class="math inline">\({G}_{\mathrm{perf}}\)</span> is the underlying perfect-information game and <span class="math inline">\(I\)</span> is <span class="math inline">\(|N|\)</span>-tuple of information sets for each player. As the perfect-information corresponding game <span class="math inline">\({G}_{\mathrm{perf}}\)</span> is a tuple <span class="math inline">\({G}_{\mathrm{perf}} = \left( N, A, H, Z, \chi, \rho, \pi, h_0, \boldsymbol{u} \right)\)</span>, we can prescribe it as</p>
<ul>
<li><span class="math inline">\(N = \left\{1,2\right\}\)</span> is the set of players;</li>
<li><span class="math inline">\(A = \left\{\mathrm{R}, \mathrm{P}, \mathrm{S}\right\}\)</span> is the set of all possible actions;</li>
<li><span class="math inline">\(H = \left\{h_0, h_1, h_2, h_3\right\}\)</span> is the set of all <em>non-terminal</em> nodes;</li>
<li><span class="math inline">\(Z = \left\{h_4, h_5, \dots, h_{12}\right\}\)</span> is the set of all <em>terminal</em> nodes;</li>
<li><span class="math inline">\(\chi : H \to (2^A \setminus \left\{\emptyset\right\})\)</span> is the action function, which assigns to each non-terminal node a set of enabled actions, thus <span class="math inline">\(\chi(h_0) = \chi(h_1) = \chi(h_2) = \chi(h_3) = A = \left\{\mathrm{R}, \mathrm{P}, \mathrm{S}\right\}\)</span>;</li>
<li><span class="math inline">\(\rho: H \to N\)</span> is the player function, which assigns to each non-terminal node <span class="math inline">\(h\)</span> a player <span class="math inline">\(i \in N\)</span> who chooses from the enabled actions <span class="math inline">\(\chi(h)\)</span>, thus <span class="math inline">\(\rho(h_0) = 1\)</span> and <span class="math inline">\(\rho(h_1) = \rho(h_2) = \rho(h_3) = 2\)</span>;</li>
<li><span class="math inline">\(\pi: H \times A \to \mathcal{H} \setminus \left\{h_0\right\}\)</span> is the successor function, which maps a non-terminal node <span class="math inline">\(h\)</span> and a choice of enabled action <span class="math inline">\(a \in \chi(h)\)</span> a new node <span class="math inline">\(h' \in \mathcal{H} \setminus \left\{h_0\right\} = H \cup Z \setminus \left\{h_0\right\}\)</span>, thus <span class="math display">\[
  \pi(h_0, a) = \begin{cases}
      h_1, &amp; a = \mathrm{R}, \\
      h_2, &amp; a = \mathrm{P}, \\
      h_3, &amp; a = \mathrm{S}
  \end{cases}
  \quad \&amp; \quad
  \pi(h_i, a) = \begin{cases}
      h_{1+3i}, &amp; a = \mathrm{R}, \\
      h_{2+3i}, &amp; a = \mathrm{P}, \\
      h_{3+3i}, &amp; a = \mathrm{S}
  \end{cases}
  \]</span> for <span class="math inline">\(i \in \left\{1,2,3\right\}\)</span>;</li>
<li><span class="math inline">\(h_0\)</span> is the root of the extensive-form game and it is the only node, which is not a successor of any other node;</li>
<li><span class="math inline">\(\boldsymbol{u} = (u_1, u_2)\)</span>, where <span class="math inline">\(u_i : Z \to \mathbb{R}\)</span> for every <span class="math inline">\(i \in N\)</span>, is the payoff function, which maps a terminal node to payoffs for both players, thus <span class="math display">\[
  \boldsymbol{u}(h_i) = \begin{cases}
      (\hphantom{-}0,\hphantom{-}0), &amp; i \in \left\{4, 8, 12\right\}, \\
      (-1,\hphantom{-}1), &amp; i \in \left\{5, 9, 10\right\}, \\
      (\hphantom{-}1,-1), &amp; i \in \left\{6, 7, 11\right\}
  \end{cases}
  \]</span> for <span class="math inline">\(i \in \left\{4, \dots, 12\right\}\)</span>.</li>
</ul>
<p>This way, we have correctly defined the underlying perfect-information game <span class="math inline">\({G}_{\mathrm{perf}}\)</span>. Combined with <span class="math display">\[
I = \left( \left\{\left\{h_0\right\}\right\}, \left\{\left\{h_1, h_2, h_3\right\}\right\} \right),
\]</span> this gives us rock-paper-scissors as the imperfect-information game <span class="math inline">\({G}_{\mathrm{imp}} = ({G}_{\mathrm{perf}}, I)\)</span>.</p>
</div>
<div id="exr-second" class="theorem exercise">
<p><span class="theorem-title"><strong>Exercise 2 </strong></span>Bob has been hired by Mafia to steal some valuable top-secret documents. Now that Bob has done so, he has two options: Either he <strong>d</strong>elivers the documents to Mafia, or he <strong>f</strong>lees to Europe and sells them for twice as much. If Bob flees, Mafia either decide to <strong>l</strong>eave this business and concentrate on other deals, or they start <strong>s</strong>earching for Bob. In the latter case, with probability <span class="math inline">\(p\)</span>, they eventually find Bob and kill him.</p>
<p>We model this scenario as the two-player perfect-information extensive-form game depicted in <a href="#fig-exr2-game">Figure&nbsp;2</a>.</p>
<div id="fig-exr2-game" class="quarto-figure quarto-figure-center anchored">
<figure class="figure">
<p><img src="problem_2_instr.drawio.svg" class="img-fluid figure-img"></p>
<figcaption class="figure-caption">Figure&nbsp;2: Bob-Mafia game</figcaption>
</figure>
</div>
<p>In dependence on parameter <span class="math inline">\(p\)</span>, <span class="math inline">\(0 \leq p \leq 1\)</span>, enumerate all:</p>
<ol type="a">
<li>never-best-response strategies;</li>
<li>max-min strategies;</li>
<li>Nash equilibria;</li>
<li>subgame-perfect equilibria.</li>
</ol>
</div>
<div class="solution proof">
<p><span class="proof-title"><em>Solution</em>. </span>Bob-Mafia game, the game from the instructions, see <a href="#fig-exr2-game">Figure&nbsp;2</a>, is an extensive-form game and as such can be re-written as a corresponding normal (or strategic) form game</p>
<table class="table">
<thead>
<tr class="header">
<th>↓Bob/Mafia→</th>
<th><span class="math inline">\(l\)</span></th>
<th><span class="math inline">\(s\)</span></th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td><span class="math inline">\(d\)</span></td>
<td><span class="math inline">\((10,10)\)</span></td>
<td><span class="math inline">\((10, 10)\)</span></td>
</tr>
<tr class="even">
<td><span class="math inline">\(f\)</span></td>
<td><span class="math inline">\((20, -5)\)</span></td>
<td><span class="math inline">\((20 - 120p,15p - 10)\)</span></td>
</tr>
</tbody>
</table>
<p>First and foremost, we shall concern ourselves with never-best-response strategies. For Bob, <span class="math inline">\(f\)</span> is clearly a best-response to a belief <span class="math inline">\(l\)</span> for any value of parameter <span class="math inline">\(p\)</span>. For a probability <span class="math inline">\(p &lt; \frac 1 {12}\)</span>, that is <span class="math inline">\(p \in \left[0, \frac 1 {12}\right)\)</span>, <span class="math inline">\(f\)</span> is also a best-response to a belief <span class="math inline">\(s\)</span> (for <span class="math inline">\(p = \frac 1 {12}\)</span> both <span class="math inline">\(d\)</span> and <span class="math inline">\(f\)</span> are best-responses to <span class="math inline">\(s\)</span>, while for <span class="math inline">\(p &gt; \frac 1 {12}\)</span> only <span class="math inline">\(d\)</span> is a best-response to <span class="math inline">\(s\)</span>). Thus for <span class="math inline">\(p \in \left[0, \frac 1 {12}\right)\)</span>, <span class="math inline">\(d\)</span> is a never-best-response. For Mafia, for any value of the parameter <span class="math inline">\(p\)</span>, both <span class="math inline">\(l\)</span> and <span class="math inline">\(s\)</span> are best-responses to the belief <span class="math inline">\(d\)</span>, hence there is no never-best-response for Mafia.</p>
<p>Continuing to max-min strategies, we can realize we were tasked with finding <strong>only pure</strong> strategies, thus we can omit mixed strategies from our analysis (although it can be shown that in this case, max-min strategies only realize as pure). Again we shall first focus on Bob, for which any max-min strategy <span class="math inline">\(s^M_{\text{Bob}}\)</span> satisfies (see the <a href="https://is.muni.cz/auth/el/fi/podzim2023/IA168/um/OLD_games_slides.pdf#page=348">definition of max-min strategy</a>) <span class="math display">\[
s^M_{\text{Bob}} \in \mathop{\mathrm{argmax}}_{s \in \left\{d, f\right\}} \min_{s' \in \left\{l, s\right\}} u_1(s, s').
\]</span></p>
<p>Recall that for <span class="math inline">\(p = \frac 1 {12}\)</span> the payoff <span class="math inline">\(\boldsymbol{u}(f,s)\)</span> has the value <span class="math inline">\(\boldsymbol{u}(f,s) = (10, -8.75)\)</span>. Hence for Bob and <span class="math inline">\(p &lt; \frac 1 {12}\)</span>, it is always better to play <span class="math inline">\(f\)</span> no matter the choice of Mafia. For <span class="math inline">\(p = \frac 1 {12}\)</span>, both strategies <span class="math inline">\(f\)</span> and <span class="math inline">\(d\)</span> provide maximal payoff in the worst-case scenario. Lastly, for <span class="math inline">\(p &gt; \frac 1 {12}\)</span>, it becomes better for Bob to stick to <span class="math inline">\(d\)</span>, as <span class="math inline">\(u_1(f,s) &lt; u_1(d,s)\)</span> given the currently considered parameter value. Combined we get, that Bob’s max-min strategy <span class="math inline">\(s^M_{\text{Bob}}\)</span> is given by <span class="math display">\[
s^M_{\text{Bob}} \in \begin{cases}
    \left\{f\right\}, &amp; p &lt; \frac 1 {12}, \\
    \left\{d,f\right\}, &amp; p = \frac 1 {12}, \\
    \left\{d\right\}, &amp; p &gt; \frac 1 {12}.
\end{cases}.
\]</span></p>
<p>For the Mafia, their max-min strategies <span class="math inline">\(s^M_{\text{Mafia}}\)</span> will analogously satisfy <span class="math display">\[
s^M_{\text{Mafia}} \in \mathop{\mathrm{argmax}}_{s' \in \left\{l,s\right\}} \min_{s \in \left\{d,f\right\}} u_2(s, s').
\]</span></p>
<p>Using similar reasoning as above, for <span class="math inline">\(p = \frac 1 3\)</span>, both strategies <span class="math inline">\(l\)</span> and <span class="math inline">\(s\)</span> provide the same payoff of -5 in the worst-case scenario, where Bob plays <span class="math inline">\(f\)</span>. On the contrary, for <span class="math inline">\(p &lt; \frac 1 3\)</span>, the strategy <span class="math inline">\(l\)</span> proves to be “better” (in the current sense of max-min strategies) as it minimizes the harm Bob can do to the Mafia by <strong>f</strong>leeing (i.e.&nbsp;playing <span class="math inline">\(f\)</span>). Unsurprisingly, for <span class="math inline">\(p &gt; \frac 1 3\)</span>, strategy <span class="math inline">\(s\)</span> turns out to have a better worst-case scenario payoff. Again, combining these results leads us to max-min strategy <span class="math inline">\(s^M_{\text{Mafia}}\)</span> given by <span class="math display">\[
s^M_{\text{Mafia}} \in \begin{cases}
    \left\{l\right\}, &amp; p &lt; \frac 1 3, \\
    \left\{l,s\right\}, &amp; p = \frac 1 3, \\
    \left\{s\right\}, &amp; p &gt; \frac 1 3.
\end{cases}
\]</span></p>
<p>Turning our attention to Nash equilibria, for <span class="math inline">\(p &lt; \frac 1 {12}\)</span>, the Mafia should not <strong>s</strong>earch for Bob (it would be wasteful – worse in terms of payoff – for them to search for him and also Bob does not concern himself too much with the search in this situation), hence Bob should <strong>f</strong>lee. This gives us the only Nash equilibrium <span class="math inline">\((f,l)\)</span> given the current parameter value.</p>
<p>Considering the parameter <span class="math inline">\(p \in \left[\frac 1 {12}, \frac 1 3\right]\)</span>, the search now becomes risky enough for Bob to seriously consider, i.e.&nbsp;should the Mafia <strong>s</strong>earch, Bob will rather <strong>d</strong>eliver the documents. At the same time, <strong>s</strong>earching is still too resource-intensive, i.e.&nbsp;provides a worse payoff, in the case that Bob actually <strong>f</strong>lees. This implies there are now 2 Nash equilibria <span class="math inline">\((d,s)\)</span> and <span class="math inline">\((f,l)\)</span>.</p>
<p>Finally, for <span class="math inline">\(p &gt; \frac 1 3\)</span>, the search is now risky for Bob and profitable for the Mafia, which forces Bob to <strong>d</strong>eliver the documents under the threat of <strong>s</strong>earch. All in all, this produces one Nash equilibrium <span class="math inline">\((d,s)\)</span>. All of these Nash equilibria for given values of parameter <span class="math inline">\(p\)</span> can be easily checked.</p>
<p>Last, but not least, realize that <a href="https://is.muni.cz/auth/el/fi/podzim2023/IA168/um/OLD_games_slides.pdf#page=472">Theorem 45</a> holds for this game, as it is finite. This implies that for <span class="math inline">\(p \in \left[0, \frac 1 {12}\right) \cap \left(\frac 1 3, 1\right]\)</span>, found Nash equilibria are automatically also subgame-perfect.</p>
<p>Consider now <span class="math inline">\(p \in \left[\frac 1 {12}, \frac 1 3\right)\)</span>, then as <span class="math inline">\(u_2(f, l) &gt; u_2(f,s)\)</span> holds, it follows that Mafia is non-credibly threating to <strong>s</strong>earch in the <span class="math inline">\((d,s)\)</span> Nash equilibrium, hence it is <strong>not</strong> subgame-perfect. The only subgame perfect equilibrium is <span class="math inline">\((f,l)\)</span> for this parameter range.</p>
<p>The only remaining situation, <span class="math inline">\(p = \frac 1 3\)</span>, means that for the Mafia it is equally profitable (giving the same payoff) to either <strong>l</strong>eave Bob alone or <strong>s</strong>earch for him in case he <strong>f</strong>lees. Thus <strong>s</strong>earching is now a credible threat, which leads to the conclusion that both <span class="math inline">\((d,s)\)</span> and <span class="math inline">\((f,l)\)</span> are subgame-perfect equilibria for <span class="math inline">\(p = \frac 1 3\)</span>.</p>
</div>
<div id="exr-third" class="theorem exercise">
<p><span class="theorem-title"><strong>Exercise 3 </strong></span>Consider the <strong>one-player</strong> perfect-information extensive-form game depicted in <a href="#fig-exr3-game">Figure&nbsp;3</a>.</p>
<div id="fig-exr3-game" class="quarto-figure quarto-figure-center anchored">
<figure class="figure">
<p><img src="problem_3_instr.drawio.svg" class="img-fluid figure-img"></p>
<figcaption class="figure-caption">Figure&nbsp;3: Exercise 3 game</figcaption>
</figure>
</div>
<p>In this game, consider a mixed strategy <span class="math inline">\(\sigma\)</span> given as follows: <span id="eq-pdist"><span class="math display">\[
\begin{aligned}
    &amp;\sigma(ACEHJLM) &amp; &amp;= &amp; &amp; \frac 4 {15} \\
    &amp;\sigma(ACEIKLN) &amp; &amp;= &amp; &amp; \frac 2 5 \\
    &amp;\sigma(BCFHKLM) &amp; &amp;= &amp; &amp; \frac 1 8 \\
    &amp;\sigma(BDFHJLN) &amp; &amp;= &amp; &amp; \frac 1 {24} \\
    &amp;\sigma(BDGHJLN) &amp; &amp;= &amp; &amp; \frac 1 6
\end{aligned}
\tag{1}\]</span></span></p>
<p>Find a behavioral strategy <span class="math inline">\(\beta\)</span> which is equivalent to <span class="math inline">\(\sigma\)</span>. Is there a unique solution to this task? Justify your answer.</p>
</div>
<div class="solution proof">
<p><span class="proof-title"><em>Solution</em>. </span>By looking at <a href="#fig-exr3-game">Figure&nbsp;3</a>, we can determine it is a one-player perfect-information extensive-form game. More so, we have a mixed strategy <span class="math inline">\(\sigma\)</span> given by (<a href="#eq-pdist">1</a>) and our goal is to find an equivalent behavioral strategy <span class="math inline">\(\beta\)</span>.</p>
<p>First and foremost, we can assign probabilities to actions (or edges):</p>
<ul>
<li>action <span class="math inline">\(A\)</span> shall be played from <span class="math inline">\(h_0\)</span> (i.e.&nbsp;playing edge <span class="math inline">\(A\)</span>) with probability <span class="math inline">\(a\)</span> and <span class="math inline">\(B\)</span> with probability <span class="math inline">\(1 - a\)</span>;</li>
<li><span class="math inline">\(C\)</span> with prob. <span class="math inline">\(b\)</span> and <span class="math inline">\(D\)</span> with prob. <span class="math inline">\(1 - b\)</span>;</li>
<li><span class="math inline">\(E\)</span> with prob. <span class="math inline">\(c_1\)</span>, <span class="math inline">\(F\)</span> with prob. <span class="math inline">\(c_2\)</span> and lastly <span class="math inline">\(G\)</span> with prob. <span class="math inline">\(1 - c_1 - c_2\)</span>;</li>
<li><span class="math inline">\(H\)</span> with prob. <span class="math inline">\(d\)</span> and <span class="math inline">\(I\)</span> with prob. <span class="math inline">\(1 - d\)</span>;</li>
<li><span class="math inline">\(J\)</span> with prob. <span class="math inline">\(e\)</span> and <span class="math inline">\(K\)</span> with prob. <span class="math inline">\(1 - e\)</span>;</li>
<li><span class="math inline">\(L\)</span> with probability <span class="math inline">\(1\)</span>, as there is nothing else to choose in <span class="math inline">\(h_5\)</span>;</li>
<li><span class="math inline">\(M\)</span> with prob. <span class="math inline">\(f\)</span> and <span class="math inline">\(N\)</span> with prob. <span class="math inline">\(1 - f\)</span>.</li>
</ul>
<p>In the lectures, the following statement was presented (modified to be applicable right away to our problem):</p>
<blockquote class="blockquote">
<p>Given a behavioral strategy <span class="math inline">\(\beta\)</span> (which implicitly gives a profile <span class="math inline">\((\beta)\)</span> in our one-player extensive-form game), we denote by <span class="math inline">\(P_\beta (z)\)</span> the probability of reaching <span class="math inline">\(z \in Z\)</span> when <span class="math inline">\(\beta\)</span> is used, i.e. <span id="eq-behav-str"><span class="math display">\[
P_\beta (z) = \prod_{l = 1}^k \beta(h_l)(a_l),
\tag{2}\]</span></span> where <span class="math inline">\(h_0a_1h_1a_2h_2\cdots a_kh_k\)</span> is the unique path from <span class="math inline">\(h_0\)</span> to <span class="math inline">\(h_k = z\)</span>.</p>
</blockquote>
<p>Considering our presented notation and the statement from lectures, we can obtain the following set of equations by enumerating through (<a href="#eq-pdist">1</a>)</p>
<p><span id="eq-mixed-to-behav"><span class="math display">\[
\begin{aligned}
    &amp;P_\beta(z_0) = \beta(h_0)(A) \beta(h_1)(C)\beta(h_3)(H)    &amp; &amp;= abd = \sigma(ACEHJLM)                  = \frac 4 {15} \\
    &amp;P_\beta(z_1) = \beta(h_0)(A) \beta(h_1)(C)\beta(h_3)(I)    &amp; &amp;= ab(1-d) = \sigma(ACEIKLN)              = \frac 2 5 \\
    &amp;P_\beta(z_2) = \beta(h_0)(A) \beta(h_1)(D)\beta(h_3)(J)    &amp; &amp;= a(1-b)e                                = 0 \\
    &amp;P_\beta(z_3) = \beta(h_0)(A) \beta(h_1)(D)\beta(h_3)(K)    &amp; &amp;= a(1-b)(1-e)                            = 0 \\
    &amp;P_\beta(z_4) = \beta(h_0)(B) \beta(h_1)(E)\beta(h_3)(L)    &amp; &amp;= (1-a)c_1\cdot 1                        = 0 \\
    &amp;P_\beta(z_5) = \beta(h_0)(B) \beta(h_1)(F)\beta(h_3)(M)    &amp; &amp;= (1-a)c_2 f = \sigma(BCFHKLM)           = \frac 1 8 \\
    &amp;P_\beta(z_6) = \beta(h_0)(B) \beta(h_1)(F)\beta(h_3)(M)    &amp; &amp;= (1-a)c_2 (1-f) = \sigma(BDFHJLN)       = \frac 1 {24} \\
    &amp;P_\beta(z_7) = \beta(h_0)(B) \beta(h_1)(G)                 &amp; &amp;= (1-a)(1-c_1 - c_2) = \sigma(BDGHJLN)   = \frac 1 6 \\
\end{aligned}
\tag{3}\]</span></span></p>
<p>First of all, one should notice that from (<a href="#eq-mixed-to-behav">3</a>) follows that <span class="math inline">\(a,b,d,c_2,f\)</span> are positive and also that <span class="math inline">\(a,d,f\)</span> are strictly less than 1. Using <span class="math inline">\(P_\beta(z_0)\)</span> and <span class="math inline">\(P_\beta(z_1)\)</span> from (<a href="#eq-mixed-to-behav">3</a>), we can deduce <span class="math display">\[
\frac {4} {15d} = ab = \frac 2 {5(1-d)} \implies d = \frac 2 5.
\]</span></p>
<p>As <span class="math inline">\(P_\beta(z_4)\)</span> clearly implies <span class="math inline">\(c_1 = 0\)</span>, similar to what we did before, from <span class="math inline">\(P_\beta(z_5)\)</span> and <span class="math inline">\(P_\beta(z_6)\)</span> one can argument <span class="math display">\[
\frac 1 {8f} = (1 - a)c_2 = \frac 1 {24(1 - f)} \implies f = \frac 3 4.
\]</span></p>
<p>Using the computed value for <span class="math inline">\(f\)</span> and <span class="math inline">\(c_1\)</span>, we can write <span class="math display">\[
8 \cdot \left( (1-a)c_2 \frac 3 4 \right) = 6 \cdot \left( (1 - a)(1-c_2) \right) \implies c_2 = \frac 1 2,
\]</span> from which we immediately get <span class="math inline">\(a = \frac 2 3\)</span> using the last equation of (<a href="#eq-mixed-to-behav">3</a>) with now known values of <span class="math inline">\(c_1\)</span> and <span class="math inline">\(c_2\)</span>. Finally, this means (given the first equation of (<a href="#eq-mixed-to-behav">3</a>)) that <span class="math inline">\(b = 1\)</span>, and shifting our focus to <span class="math inline">\(P_\beta(z_2)\)</span> and <span class="math inline">\(P_\beta(z_3)\)</span> shows us that <span class="math inline">\(e\)</span> can be chosen arbitrarily such that <span class="math inline">\(e \in [0,1]\)</span>.</p>
<p>Our observations combined amount to the fact that the desired behavioral strategy <strong>is not unique</strong> and for a value of parameter <span class="math inline">\(e \in [0,1]\)</span> it has the following defining properties</p>
<ul>
<li><span class="math inline">\(\beta(h_0)(A) = \frac 2 3\;(= a)\)</span> and <span class="math inline">\(\beta(h_0)(B) = \frac 1 3 \;(= 1 - a)\)</span>;</li>
<li><span class="math inline">\(\beta(h_1)(C) = 1 \;(= b)\)</span> and <span class="math inline">\(\beta(h_1)(D) = 0 \;(= 1 - b)\)</span>;</li>
<li><span class="math inline">\(\beta(h_2)(E) = 0 \;(= c_1)\)</span>, <span class="math inline">\(\beta(h_2)(F) = \frac 1 2 \;(= c_2)\)</span> and <span class="math inline">\(\beta(h_2)(G) = \frac 1 2 \;(= 1 - c_1 - c_2)\)</span>;</li>
<li><span class="math inline">\(\beta(h_3)(H) = \frac 2 5 \;(= d)\)</span> and <span class="math inline">\(\beta(h_3)(I) = \frac 3 5 \;(=1 - d)\)</span>;</li>
<li><span class="math inline">\(\beta(h_4)(J) = e\)</span> and <span class="math inline">\(\beta(h_4)(K) = 1 - e\)</span>;</li>
<li><span class="math inline">\(\beta(h_5)(L) = 1\)</span>;</li>
<li><span class="math inline">\(\beta(h_6)(M) = \frac 3 4 \;(= f)\)</span> and <span class="math inline">\(\beta(h_6)(N) = \frac 1 4 \;(= 1 - f)\)</span>.</li>
</ul>
</div>
<div id="exr-fourth" class="theorem exercise">
<p><span class="theorem-title"><strong>Exercise 4 </strong></span>Find a two-player perfect-information extensive-form game where all of the following conditions are satisfied:</p>
<ul>
<li>there is a strategy profile whose outcome is for both players better than that of any Nash equilibrium;</li>
<li>there is a Nash equilibrium whose outcome is for both players better than that of any subgame-perfect equilibrium;</li>
<li>there are exactly two subgame-perfect equilibria <span class="math inline">\(s, s'\)</span>, and the outcome of <span class="math inline">\(s\)</span> is for both players better than that of <span class="math inline">\(s'\)</span>.</li>
</ul>
<p>Should you fail to find such a game, try your best (for partial points) to find a game which matches the requirements as closely as you can.</p>
</div>
<div class="solution proof">
<p><span class="proof-title"><em>Solution</em>. </span>Consider a two-player perfect-information extensive-form game <span class="math inline">\(G\)</span> given by the following graph, see <a href="#fig-exr4-sol">Figure&nbsp;4</a>.</p>
<div id="fig-exr4-sol" class="quarto-figure quarto-figure-center anchored">
<figure class="figure">
<p><img src="problem_4_sol.drawio.svg" class="img-fluid figure-img"></p>
<figcaption class="figure-caption">Figure&nbsp;4: Graph of the game <span class="math inline">\(G\)</span></figcaption>
</figure>
</div>
<p>Notice that the right subtree (i.e.&nbsp;subgame rooted in <span class="math inline">\(h_2\)</span>) is a modification of the centipede game, which is constructed such that “being <strong>d</strong>one with the game”, represented by strategies <span class="math inline">\(D_i\)</span> for <span class="math inline">\(i \in \left\{1, \dots, 3\right\}\)</span>, is better for the corresponding player than the subgame-perfect equilibrium of the subgame rooted in <span class="math inline">\(A_i\)</span>, which stands for “playing <strong>a</strong>long”. In this subgame, a strategy profile leading to the terminal node <span class="math inline">\(z_6\)</span> provides outcome <span class="math inline">\((7,5)\)</span>, which is better than the payoff of any Nash equilibrium of <span class="math inline">\(G\)</span>.</p>
<p>The middle subgame, rooted in <span class="math inline">\(h_1\)</span>, features 2 subgame perfect equilibria, which in the full game <span class="math inline">\(G\)</span> are <span class="math display">\[
    \hat s_1 = ((S, W, D_2, N_2), (O, D_1, D_3, C)) \quad \&amp; \quad \hat s_2 = ((S, B, D_2, N_2), (P, D_1, D_3, C)).
\]</span> It is easy to check they are truly subgame-perfect equilibria by considering all possible one-step deviations.</p>
<p>Finally, the leftmost subgame <span class="math inline">\(G_L\)</span>, rooted in <span class="math inline">\(h'_1\)</span>, contains a Nash equlibrium <span class="math inline">\(\hat s^{G_L}_1 = ((NT), (N_1))\)</span> and a subgame-perfect equilibrium <span class="math inline">\(\hat s^{G_L}_2 = ((N_2), (C))\)</span>. When we consider <span class="math inline">\(G_L\)</span> not on its own, but as a subgame of the whole game <span class="math inline">\(G\)</span>, we will see that <span class="math inline">\(\hat s^{G_L}_2\)</span> ceases being an equilibrium. Unlike <span class="math inline">\(\hat s^{G_L}_2\)</span>, <span class="math inline">\(\hat s^{G_L}_1\)</span> remains a Nash equilibrium in <span class="math inline">\(G\)</span> when properly extended to the full game <span class="math inline">\(G\)</span>, e.g. <span class="math display">\[
\hat s^N_1 = ((N, W, D_2, NT), (O, D_1, D_3, N_1)).
\]</span></p>
<p>As <span class="math inline">\(s^N_1\)</span> retains payoff <span class="math inline">\(\boldsymbol{u} \left( s^N_1 \right) = (4,4) &gt; (1,2) = \boldsymbol{u}(\hat s_1)\)</span>, and <span class="math inline">\(\boldsymbol{u}\left( s^N_1 \right) = (4,4) &gt; (2,3) = \boldsymbol{u} (\hat s_2)\)</span>, we found the desired Nash equilibrium, which concludes the solution to this exercise.</p>
</div>
<div id="exr-fifth" class="theorem exercise">
<p><span class="theorem-title"><strong>Exercise 5 </strong></span>Prove or disprove: In every <strong>zero-sum</strong> two-player perfect-information extensive-form game <span class="math inline">\(G\)</span>, all subgame-perfect equilibria have the same outcome for player 1.</p>
</div>
<div class="solution proof">
<p><span class="proof-title"><em>Solution</em>. </span>Consider a zero-sum two-player perfection-information extensive-form game <span class="math display">\[
G = (N, A, H, Z, \chi, \rho, \pi, h_0, \boldsymbol{u}(z)),
\]</span> such that <span class="math inline">\(N = \left\{1,2\right\}\)</span> and <span class="math inline">\(\boldsymbol{u}(z) = (v(z), -v(z))\)</span>. For this game <span class="math inline">\(G\)</span>, the conditions of the <a href="https://is.muni.cz/auth/el/fi/podzim2023/IA168/um/OLD_games_slides.pdf#page=472">Theorem 45</a>, which states</p>
<blockquote class="blockquote">
<p>For every finite perfect-information extensive-form game and for each node <span class="math inline">\(h \in H\)</span> the attached <span class="math inline">\(s^h\)</span> is a <strong>subgame-perfect equilibrium</strong> (SPE) and the attached vector satisfies <span class="math display">\[
\boldsymbol{u}(h) = \boldsymbol{u}(s^h) = (u_1(s^h), \dots, u_n(s^n))
\]</span></p>
</blockquote>
<p>are met if <span class="math inline">\(G\)</span> is <strong>finite</strong>.</p>
<p>Consider two (possibly different) SPEs <span class="math inline">\(s, s^*\)</span>. Should they result in the same terminal node <span class="math inline">\(z\)</span> (or two terminal nodes giving the same value <span class="math inline">\(\boldsymbol{u}(z)\)</span>), the statement is trivially true. Therefore suppose that when both players play the strategy profile <span class="math inline">\(s\)</span>, or <span class="math inline">\(s^*\)</span>, the game results in <span class="math inline">\(z\)</span>, or respectively <span class="math inline">\(z^*\)</span>, such that <span class="math inline">\(z \neq z^*\)</span> and <span class="math inline">\(\boldsymbol{u}(z) = \boldsymbol{u}(s) \neq \boldsymbol{u}(s^*) = \boldsymbol{u}(z^*)\)</span> (otherwise the statement is again trivially satisfied). Surely, both <span class="math inline">\(z\)</span> and <span class="math inline">\(z^*\)</span> are descendants of <span class="math inline">\(h_0\)</span>. Thus there exists a node <span class="math inline">\(h \in H\)</span>, such that <span class="math inline">\(h\)</span> is an ancestor of both <span class="math inline">\(z\)</span> and <span class="math inline">\(z^*\)</span>, but the successor <span class="math inline">\(h_s = \pi(h, s(h))\)</span>, and <span class="math inline">\(h_{s^*} = \pi(h, s^*(h))\)</span>, is not an ancestor of <span class="math inline">\(z^*\)</span>, respectively <span class="math inline">\(h_{s^*}\)</span> is not an ancestor of <span class="math inline">\(z\)</span>.</p>
<p>Using the <a href="https://is.muni.cz/auth/el/fi/podzim2023/IA168/um/OLD_games_slides.pdf#page=472">Theorem 45</a> and the fact that <span class="math inline">\(s\)</span> is a SPE in <span class="math inline">\(G\)</span> (but also in <span class="math inline">\(G^h\)</span> and <span class="math inline">\(G^{h_s}\)</span>), <span class="math inline">\(s\)</span> must provide a best-response action <span class="math inline">\(a \in \chi(h)\)</span> to any belief <span class="math inline">\(b\)</span> in the subgame <span class="math inline">\(G^h\)</span>. As discussed before, here <span class="math inline">\(a = h_s\)</span> and we obtain <span id="eq-s-spe"><span class="math display">\[
\boldsymbol{u}(h) = \boldsymbol{u}(s^h) = \boldsymbol{u}(s^{h_s}) = \boldsymbol{u}(z).
\tag{4}\]</span></span></p>
<p>Similarly, <span class="math inline">\(s^*\)</span> is also an SPE in <span class="math inline">\(G\)</span>, hence <span id="eq-sstar-spe"><span class="math display">\[
\boldsymbol{u}(h) = \boldsymbol{u}(s^h) = \boldsymbol{u}(s^{h_{s^*}}) = \boldsymbol{u}(z^*).
\tag{5}\]</span></span></p>
<p>Recall that <span class="math inline">\(G\)</span> is a <strong>zero-sum</strong> game, thus WLOG (otherwise we could simply swap their “names”) this leads to <span id="eq-spes"><span class="math display">\[
u_1(z) &gt; u_1(z^*) \quad \&amp; \quad u_2(z) &lt; u_2(z^*)
\tag{6}\]</span></span> for <span class="math inline">\(z, z^*\)</span> as we have assumed them (providing different payoffs). Now presume, that player 1 chooses an action in node <span class="math inline">\(h\)</span>, i.e.&nbsp;<span class="math inline">\(\rho(h) = 1\)</span>. Then from (<a href="#eq-s-spe">4</a>) we get <span class="math inline">\(u_1(h) = u_1(z)\)</span>, but from (<a href="#eq-sstar-spe">5</a>) also <span class="math display">\[
u_1(z) = u_1(h) = u_1(h) = u_1(z^*),
\]</span> which contradicts (<a href="#eq-spes">6</a>). Analogously, for the case <span class="math inline">\(\rho(h) = 2\)</span>, we get a similar contradiction.</p>
<p>It shall also be noted that <a href="https://is.muni.cz/auth/el/fi/podzim2023/IA168/um/OLD_games_slides.pdf#page=472">Theorem 45</a> only applies to <strong>finite</strong> games – infinite games may not have any subgame-perfect equilibrium. But if there exists a SPE in an infinite game <span class="math inline">\(G\)</span>, then there exists a SPE for all subgames. Hence our reasoning is still valid because for every non-terminal node, we can compare its corresponding subgame-perfect equilibria (more precisely their payoffs).</p>
<p>Altogether, we have shown that there cannot be two SPEs <span class="math inline">\(s,s^*\)</span> in a zero-sum two-player perfect-information extensive-form game <span class="math inline">\(G\)</span>, such that <span class="math inline">\(\boldsymbol{u}(s) \neq \boldsymbol{u}(s^*)\)</span>.</p>
</div>

</main>
<!-- /main column -->
<script id="quarto-html-after-body" type="application/javascript">
window.document.addEventListener("DOMContentLoaded", function (event) {
  const toggleBodyColorMode = (bsSheetEl) => {
    const mode = bsSheetEl.getAttribute("data-mode");
    const bodyEl = window.document.querySelector("body");
    if (mode === "dark") {
      bodyEl.classList.add("quarto-dark");
      bodyEl.classList.remove("quarto-light");
    } else {
      bodyEl.classList.add("quarto-light");
      bodyEl.classList.remove("quarto-dark");
    }
  }
  const toggleBodyColorPrimary = () => {
    const bsSheetEl = window.document.querySelector("link#quarto-bootstrap");
    if (bsSheetEl) {
      toggleBodyColorMode(bsSheetEl);
    }
  }
  toggleBodyColorPrimary();  
  const disableStylesheet = (stylesheets) => {
    for (let i=0; i < stylesheets.length; i++) {
      const stylesheet = stylesheets[i];
      stylesheet.rel = 'prefetch';
    }
  }
  const enableStylesheet = (stylesheets) => {
    for (let i=0; i < stylesheets.length; i++) {
      const stylesheet = stylesheets[i];
      stylesheet.rel = 'stylesheet';
    }
  }
  const manageTransitions = (selector, allowTransitions) => {
    const els = window.document.querySelectorAll(selector);
    for (let i=0; i < els.length; i++) {
      const el = els[i];
      if (allowTransitions) {
        el.classList.remove('notransition');
      } else {
        el.classList.add('notransition');
      }
    }
  }
  const toggleColorMode = (alternate) => {
    // Switch the stylesheets
    const alternateStylesheets = window.document.querySelectorAll('link.quarto-color-scheme.quarto-color-alternate');
    manageTransitions('#quarto-margin-sidebar .nav-link', false);
    if (alternate) {
      enableStylesheet(alternateStylesheets);
      for (const sheetNode of alternateStylesheets) {
        if (sheetNode.id === "quarto-bootstrap") {
          toggleBodyColorMode(sheetNode);
        }
      }
    } else {
      disableStylesheet(alternateStylesheets);
      toggleBodyColorPrimary();
    }
    manageTransitions('#quarto-margin-sidebar .nav-link', true);
    // Switch the toggles
    const toggles = window.document.querySelectorAll('.quarto-color-scheme-toggle');
    for (let i=0; i < toggles.length; i++) {
      const toggle = toggles[i];
      if (toggle) {
        if (alternate) {
          toggle.classList.add("alternate");     
        } else {
          toggle.classList.remove("alternate");
        }
      }
    }
    // Hack to workaround the fact that safari doesn't
    // properly recolor the scrollbar when toggling (#1455)
    if (navigator.userAgent.indexOf('Safari') > 0 && navigator.userAgent.indexOf('Chrome') == -1) {
      manageTransitions("body", false);
      window.scrollTo(0, 1);
      setTimeout(() => {
        window.scrollTo(0, 0);
        manageTransitions("body", true);
      }, 40);  
    }
  }
  const isFileUrl = () => { 
    return window.location.protocol === 'file:';
  }
  const hasAlternateSentinel = () => {  
    let styleSentinel = getColorSchemeSentinel();
    if (styleSentinel !== null) {
      return styleSentinel === "alternate";
    } else {
      return false;
    }
  }
  const setStyleSentinel = (alternate) => {
    const value = alternate ? "alternate" : "default";
    if (!isFileUrl()) {
      window.localStorage.setItem("quarto-color-scheme", value);
    } else {
      localAlternateSentinel = value;
    }
  }
  const getColorSchemeSentinel = () => {
    if (!isFileUrl()) {
      const storageValue = window.localStorage.getItem("quarto-color-scheme");
      return storageValue != null ? storageValue : localAlternateSentinel;
    } else {
      return localAlternateSentinel;
    }
  }
  let localAlternateSentinel = 'default';
  // Dark / light mode switch
  window.quartoToggleColorScheme = () => {
    // Read the current dark / light value 
    let toAlternate = !hasAlternateSentinel();
    toggleColorMode(toAlternate);
    setStyleSentinel(toAlternate);
  };
  // Ensure there is a toggle, if there isn't float one in the top right
  if (window.document.querySelector('.quarto-color-scheme-toggle') === null) {
    const a = window.document.createElement('a');
    a.classList.add('top-right');
    a.classList.add('quarto-color-scheme-toggle');
    a.href = "";
    a.onclick = function() { try { window.quartoToggleColorScheme(); } catch {} return false; };
    const i = window.document.createElement("i");
    i.classList.add('bi');
    a.appendChild(i);
    window.document.body.appendChild(a);
  }
  // Switch to dark mode if need be
  if (hasAlternateSentinel()) {
    toggleColorMode(true);
  } else {
    toggleColorMode(false);
  }
  const icon = "";
  const anchorJS = new window.AnchorJS();
  anchorJS.options = {
    placement: 'right',
    icon: icon
  };
  anchorJS.add('.anchored');
  const isCodeAnnotation = (el) => {
    for (const clz of el.classList) {
      if (clz.startsWith('code-annotation-')) {                     
        return true;
      }
    }
    return false;
  }
  const clipboard = new window.ClipboardJS('.code-copy-button', {
    text: function(trigger) {
      const codeEl = trigger.previousElementSibling.cloneNode(true);
      for (const childEl of codeEl.children) {
        if (isCodeAnnotation(childEl)) {
          childEl.remove();
        }
      }
      return codeEl.innerText;
    }
  });
  clipboard.on('success', function(e) {
    // button target
    const button = e.trigger;
    // don't keep focus
    button.blur();
    // flash "checked"
    button.classList.add('code-copy-button-checked');
    var currentTitle = button.getAttribute("title");
    button.setAttribute("title", "Copied!");
    let tooltip;
    if (window.bootstrap) {
      button.setAttribute("data-bs-toggle", "tooltip");
      button.setAttribute("data-bs-placement", "left");
      button.setAttribute("data-bs-title", "Copied!");
      tooltip = new bootstrap.Tooltip(button, 
        { trigger: "manual", 
          customClass: "code-copy-button-tooltip",
          offset: [0, -8]});
      tooltip.show();    
    }
    setTimeout(function() {
      if (tooltip) {
        tooltip.hide();
        button.removeAttribute("data-bs-title");
        button.removeAttribute("data-bs-toggle");
        button.removeAttribute("data-bs-placement");
      }
      button.setAttribute("title", currentTitle);
      button.classList.remove('code-copy-button-checked');
    }, 1000);
    // clear code selection
    e.clearSelection();
  });
  function tippyHover(el, contentFn) {
    const config = {
      allowHTML: true,
      content: contentFn,
      maxWidth: 500,
      delay: 100,
      arrow: false,
      appendTo: function(el) {
          return el.parentElement;
      },
      interactive: true,
      interactiveBorder: 10,
      theme: 'quarto',
      placement: 'bottom-start'
    };
    window.tippy(el, config); 
  }
  const noterefs = window.document.querySelectorAll('a[role="doc-noteref"]');
  for (var i=0; i<noterefs.length; i++) {
    const ref = noterefs[i];
    tippyHover(ref, function() {
      // use id or data attribute instead here
      let href = ref.getAttribute('data-footnote-href') || ref.getAttribute('href');
      try { href = new URL(href).hash; } catch {}
      const id = href.replace(/^#\/?/, "");
      const note = window.document.getElementById(id);
      return note.innerHTML;
    });
  }
      let selectedAnnoteEl;
      const selectorForAnnotation = ( cell, annotation) => {
        let cellAttr = 'data-code-cell="' + cell + '"';
        let lineAttr = 'data-code-annotation="' +  annotation + '"';
        const selector = 'span[' + cellAttr + '][' + lineAttr + ']';
        return selector;
      }
      const selectCodeLines = (annoteEl) => {
        const doc = window.document;
        const targetCell = annoteEl.getAttribute("data-target-cell");
        const targetAnnotation = annoteEl.getAttribute("data-target-annotation");
        const annoteSpan = window.document.querySelector(selectorForAnnotation(targetCell, targetAnnotation));
        const lines = annoteSpan.getAttribute("data-code-lines").split(",");
        const lineIds = lines.map((line) => {
          return targetCell + "-" + line;
        })
        let top = null;
        let height = null;
        let parent = null;
        if (lineIds.length > 0) {
            //compute the position of the single el (top and bottom and make a div)
            const el = window.document.getElementById(lineIds[0]);
            top = el.offsetTop;
            height = el.offsetHeight;
            parent = el.parentElement.parentElement;
          if (lineIds.length > 1) {
            const lastEl = window.document.getElementById(lineIds[lineIds.length - 1]);
            const bottom = lastEl.offsetTop + lastEl.offsetHeight;
            height = bottom - top;
          }
          if (top !== null && height !== null && parent !== null) {
            // cook up a div (if necessary) and position it 
            let div = window.document.getElementById("code-annotation-line-highlight");
            if (div === null) {
              div = window.document.createElement("div");
              div.setAttribute("id", "code-annotation-line-highlight");
              div.style.position = 'absolute';
              parent.appendChild(div);
            }
            div.style.top = top - 2 + "px";
            div.style.height = height + 4 + "px";
            let gutterDiv = window.document.getElementById("code-annotation-line-highlight-gutter");
            if (gutterDiv === null) {
              gutterDiv = window.document.createElement("div");
              gutterDiv.setAttribute("id", "code-annotation-line-highlight-gutter");
              gutterDiv.style.position = 'absolute';
              const codeCell = window.document.getElementById(targetCell);
              const gutter = codeCell.querySelector('.code-annotation-gutter');
              gutter.appendChild(gutterDiv);
            }
            gutterDiv.style.top = top - 2 + "px";
            gutterDiv.style.height = height + 4 + "px";
          }
          selectedAnnoteEl = annoteEl;
        }
      };
      const unselectCodeLines = () => {
        const elementsIds = ["code-annotation-line-highlight", "code-annotation-line-highlight-gutter"];
        elementsIds.forEach((elId) => {
          const div = window.document.getElementById(elId);
          if (div) {
            div.remove();
          }
        });
        selectedAnnoteEl = undefined;
      };
      // Attach click handler to the DT
      const annoteDls = window.document.querySelectorAll('dt[data-target-cell]');
      for (const annoteDlNode of annoteDls) {
        annoteDlNode.addEventListener('click', (event) => {
          const clickedEl = event.target;
          if (clickedEl !== selectedAnnoteEl) {
            unselectCodeLines();
            const activeEl = window.document.querySelector('dt[data-target-cell].code-annotation-active');
            if (activeEl) {
              activeEl.classList.remove('code-annotation-active');
            }
            selectCodeLines(clickedEl);
            clickedEl.classList.add('code-annotation-active');
          } else {
            // Unselect the line
            unselectCodeLines();
            clickedEl.classList.remove('code-annotation-active');
          }
        });
      }
  const findCites = (el) => {
    const parentEl = el.parentElement;
    if (parentEl) {
      const cites = parentEl.dataset.cites;
      if (cites) {
        return {
          el,
          cites: cites.split(' ')
        };
      } else {
        return findCites(el.parentElement)
      }
    } else {
      return undefined;
    }
  };
  var bibliorefs = window.document.querySelectorAll('a[role="doc-biblioref"]');
  for (var i=0; i<bibliorefs.length; i++) {
    const ref = bibliorefs[i];
    const citeInfo = findCites(ref);
    if (citeInfo) {
      tippyHover(citeInfo.el, function() {
        var popup = window.document.createElement('div');
        citeInfo.cites.forEach(function(cite) {
          var citeDiv = window.document.createElement('div');
          citeDiv.classList.add('hanging-indent');
          citeDiv.classList.add('csl-entry');
          var biblioDiv = window.document.getElementById('ref-' + cite);
          if (biblioDiv) {
            citeDiv.innerHTML = biblioDiv.innerHTML;
          }
          popup.appendChild(citeDiv);
        });
        return popup.innerHTML;
      });
    }
  }
});
</script>
</div> <!-- /content -->



</body></html>